VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsContextMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' Klasse zum ermitteln des ausgewhlten Menpunktes in einem
' Kontextmen. Diese Klasse funktioniert zur Zeit mit einer
' TextBox, RichTextBox, MaskEdBox und der TextBox in der ComboBox.
' Durchaus Mglich das die Klasse auch mit anderen Controls
' funktioniert die ein Kontextmen haben.

' ---=== Const ===---
Private Const GWL_WNDPROC As Long = (-4)
Private Const MIIM_STATE As Long = &H1
Private Const MFS_DISABLED As Long = &H3&
Private Const MSGF_MENU As Long = 2
Private Const WM_CHAR As Long = &H102
Private Const WM_CONTEXTMENU As Long = &H7B
Private Const WM_DESTROY As Long = &H2
Private Const WM_ENTERIDLE As Long = &H121
Private Const WM_KEYDOWN As Long = &H100
Private Const WM_MENUSELECT As Long = &H11F
Private Const WM_NCDESTROY As Long = &H82
Private Const WM_SYSKEYDOWN As Long = &H104
Private Const WM_WINDOWPOSCHANGING As Long = &H46
Private Const WM_WINDOWPOSCHANGED As Long = &H47

' ---=== Type ===---
Private Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
End Type

' ---=== USER32 ===---
Private Declare Function CallWindowProc Lib "user32" _
                         Alias "CallWindowProcA" ( _
                         ByVal lpPrevWndFunc As Long, _
                         ByVal hwnd As Long, _
                         ByVal Msg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long
                         
Private Declare Function GetMenuItemInfo Lib "user32.dll" _
                         Alias "GetMenuItemInfoA" ( _
                         ByVal hMenu As Long, _
                         ByVal uItem As Long, _
                         ByVal fByPosition As Boolean, _
                         ByRef lpMenuItemInfo As MENUITEMINFO) As Long

Private Declare Function GetMenuString Lib "user32" _
                         Alias "GetMenuStringA" ( _
                         ByVal hMenu As Long, _
                         ByVal ItemId As Long, _
                         ByVal Buffer As String, _
                         ByVal BufferMax As Long, _
                         ByVal Flag As Long) As Long
                         
Private Declare Function SetWindowLong Lib "user32" _
                         Alias "SetWindowLongA" ( _
                         ByVal hwnd As Long, _
                         ByVal nIndex As Long, _
                         ByVal dwNewLong As Long) As Long
                         
' ---=== Variablen ===---
Private m_hMenu As Long
Private m_HookWnd As Long
Private m_MenuWnd As Long
Private m_WndProc As Long
Private m_MenuProc As Long
Private m_MenuItemID As Long
Private m_MenuTracking As Boolean

' ---=== Event ===---
Public Event MouseUp(ByVal MenuHandle As Long, ByVal MenuItemID As Long, _
    ByVal MenuString As String, ByVal ScreenX As Long, ByVal ScreenY As Long)
    
Private Function GetMenuStringFromItemID(ByVal MenuItemID As Long) As _
    String
    
    Dim lngRet As Long
    Dim strMenuString As String
    
    strMenuString = Space$(256)
    
    lngRet = GetMenuString(m_hMenu, MenuItemID, strMenuString, Len( _
        strMenuString), 0&)
        
    GetMenuStringFromItemID = Left$(strMenuString, lngRet)
    
End Function

Private Sub GetSelectedMenuItem(ByVal MenuItemID As Long, Optional ByVal _
    ScreenPos As Long = 0)
    
    Dim Lo As Long
    Dim Hi As Long
    Dim lngMenuItemID As Long
    Dim tMII As MENUITEMINFO
    
    tMII.cbSize = Len(tMII)
    tMII.fMask = MIIM_STATE ' Status des MenItems
    
    ' MenItemInfo auslesen
    If GetMenuItemInfo(m_hMenu, MenuItemID, False, tMII) <> 0 Then
    
        ' Wenn der Meneintrag nicht deaktiv ist
        If (tMII.fState And MFS_DISABLED) <> MFS_DISABLED Then
        
            ' lParam in Lo und Hi aufsplitten
            Call GetShort(ScreenPos, Lo, Hi)
            
            ' Event auslsen
            RaiseEvent MouseUp(m_hMenu, MenuItemID, _
                GetMenuStringFromItemID(MenuItemID), Lo, Hi)
                
        End If
    End If
    
End Sub

Private Sub GetShort(ByVal Value As Long, ByRef Lo As Long, ByRef Hi As _
    Long)
    
    Lo = Value And &H7FFF
    Hi = Value \ &H10000
    
End Sub

Public Sub Hook(ByVal hwnd As Long)

    If m_HookWnd <> 0 Then
    
        Call UnHook
        
    End If
    
    m_HookWnd = hwnd
    colObject.Add Me, "Object" & CStr(m_HookWnd)
        
    m_WndProc = SetWindowLong(m_HookWnd, GWL_WNDPROC, AddressOf _
        ObjectProc)
            
End Sub

Private Sub HookMenu(ByVal hwnd As Long)

    If m_MenuWnd <> 0 Then
    
        Call UnHookMenu
        
    End If
    
    m_MenuWnd = hwnd
    colMenu.Add Me, "Menu" & CStr(m_MenuWnd)
        
    m_MenuProc = SetWindowLong(m_MenuWnd, GWL_WNDPROC, AddressOf _
        MenuProc)
            
End Sub

Friend Function MenuMsgRec(ByVal uMsg As Long, ByVal wParam As Long, _
    ByVal lParam As Long) As Long
    
    Dim lngMenuItemPos As Long
    
    MenuMsgRec = CallWindowProc(m_MenuProc, m_MenuWnd, uMsg, wParam, _
        lParam)
    
    Select Case uMsg
    
    Case &H1E5 'MN_SELECTITEM
    
        ' Tritt auf wenn die Maus im Men bewegt wird.
        Select Case wParam
        
        Case -1
        
            ' lParam = 0
            ' wParam = -1 Die Maus befindet sich auerhalb des Mens.
        Case Else
        
            ' Die Maus befindet sich innerhalb des Mens.
            ' lParam = 0
            ' wParam => 0 MenItemPosition
        End Select
        
    Case &H1E6 'MN_???
    
        ' Tritt auf wenn ein Item im Men mit der Maus ausgewhlt wurde
        ' aber die Maustaste auerhalb des Mens losgelassen wird.
        ' lParam = 0
        ' wParam = 0
    Case &H1ED 'MN_BUTTONDOWN
    
        ' Tritt auf wenn eine Maustaste gedrckt wird.
        ' lParam = 0
        ' wParam = MenItemPosition
    Case &H1EF 'MN_BUTTONUP
    
        ' Tritt auf wenn eine Maustaste losgelassen wird.
        ' lParam = Mausposition auf dem Bildschirm
        ' wParam = MenItemPosition
        Call GetSelectedMenuItem(m_MenuItemID, lParam)
    
    Case WM_KEYDOWN
    
        ' Tritt auf wenn eine Cursor-Taste gedrckt wird.
        ' lParam = 0
        ' wParam = Virtual Keycode
        If wParam = vbKeyReturn Then
        
            Call GetSelectedMenuItem(m_MenuItemID)
            
        End If
        
    Case WM_CHAR
    
        ' Tritt auf wenn eine andere Taste gedrckt wird.
        ' lParam = 0
        ' wParam = Char Code
    Case WM_SYSKEYDOWN
    
        ' Tritt auf wenn die ALT-Taste gedrckt wird.
        ' lParam = 0
        ' wParam = Virtual Keycode
    Case WM_WINDOWPOSCHANGING
    
        ' Tritt auf wenn die Groe, Position oder Z-Order gendert wird
        ' lParam = Zeiger auf eine WINDOWPOS Struktur
        ' wParam = 0
    Case WM_WINDOWPOSCHANGED
    
        ' Tritt auf wenn die Groe, Position oder Z-Order gendert wurde
        ' lParam = Zeiger auf eine WINDOWPOS Struktur
        ' wParam = 0
    Case WM_DESTROY
    
        ' Tritt auf wenn das Fenster zerstrt wird. Hier beenden wir
        ' das Subclassing des Menfensters.
        ' lParam = 0
        ' wParam = 0
        Call UnHookMenu
        
    Case WM_NCDESTROY
    
        ' Tritt auf wenn der NONCLIENT zerstrt wird. Tritt nach
        ' WM_DESTROY auf. Da wir aber das Subclassing schon im
        ' WM_DESTROY beenden, wird diese Nachricht nicht mehr emfpangen.
        ' lParam = 0
        ' wParam = 0
    End Select
        
End Function

Friend Function ObjectMsgRec(ByVal uMsg As Long, ByVal wParam As Long, _
    ByVal lParam As Long) As Long
    
    Dim Lo As Long
    Dim Hi As Long
    Dim bolItemDisabled As Boolean
    Dim tMII As MENUITEMINFO
    
    ObjectMsgRec = CallWindowProc(m_WndProc, m_HookWnd, uMsg, wParam, _
        lParam)
        
    Select Case uMsg
    
    Case WM_CONTEXTMENU
        
        ' Tritt auf wenn das Kontextmen aufgerufen wird.
        ' lParam = Mausposition auf dem Bildschrim
        ' wParam = Handle vom Fenster, das das Kontextmen aufgerufen hat.
         Call GetShort(lParam, Lo, Hi)

    Case WM_ENTERIDLE
    
        ' Tritt auf wenn das Kontextmen nichts zu tun hat. Also
        ' wenn keine Maus- oder Tastaturaktionen durchgefhrt werden.
        ' lParam = Handle vom Fenster, auf dem das Men dargestellt wird
        ' wParam = Dialog (MSGF_DIALOGBOX) oder Men (MSGF_MENU)
    
        ' ist es ein Men
        If wParam = MSGF_MENU Then
            
            ' ist ein FensterHandle vorhanden
            If lParam <> 0 Then
            
                ' ist ein MenHandle vorhanden
                If m_hMenu <> 0 Then
                
                    ' wenn das Subclassing des Menfensters noch nicht
                    ' gestartet wurde
                    If Not m_MenuTracking Then
                    
                        ' merken das das Subclassing gestartet wird
                        m_MenuTracking = True
                        
                        ' Menfenster subclassen
                        Call HookMenu(lParam)
                        
                    End If
                End If
            End If
        End If
        
    Case WM_MENUSELECT
        
        ' Tritt auf wenn ein Menitem selektiert wird.
        ' lParam = Handle vom Men
        ' wParam = MenItemId
        
        ' ist ein MenHandle vorhanden
        If lParam <> 0 Then
        
            ' MenHandle speichern
            m_hMenu = lParam
            
            ' MenItemID speichern
            m_MenuItemID = (wParam And &HFFFF&)
            
            ' MenItemID vorhanden
            If m_MenuItemID <> 0 Then
            
                tMII.cbSize = Len(tMII)
                tMII.fMask = MIIM_STATE ' Status des MenItems
            
                ' MenItemInfo auslesen
                If GetMenuItemInfo(m_hMenu, m_MenuItemID, False, tMII) <> 0 Then
        
                    ' Wenn der Meneintrag deaktiv ist
                    If (tMII.fState And MFS_DISABLED) = MFS_DISABLED Then
                    
                        ' speichern das dieser Menpunkt deaktiv ist
                        bolItemDisabled = True
                        
                    End If
                End If
                
                ' Debug.Print "MenuHandle = &H" & Hex$(m_hMenu)
                ' Debug.Print "MenuItemId = &H" & Hex$(m_MenuItemID)
                ' Debug.Print "MenuItemDisabled = " & CStr(bolItemDisabled)
                ' Debug.Print "MenuString = " & GetMenuStringFromItemID(m_MenuItemID)
            End If
        End If
        
    End Select
    
End Function

Public Sub UnHook()

    If m_HookWnd <> 0 Then
    
        Call SetWindowLong(m_HookWnd, GWL_WNDPROC, m_WndProc)
        
        If colObject.Count = 1 Then
        
            colObject.Remove "Object" & CStr(m_HookWnd)
            
        End If
        
        m_HookWnd = 0
        
    End If
    
End Sub

Private Sub UnHookMenu()

    If m_MenuWnd <> 0 Then
    
        Call SetWindowLong(m_MenuWnd, GWL_WNDPROC, m_MenuProc)
        
        If colMenu.Count = 1 Then
        
            colMenu.Remove "Menu" & CStr(m_MenuWnd)
            
        End If
        
        m_MenuWnd = 0
        m_MenuTracking = False
        
    End If
    
End Sub

Private Sub Class_Terminate()

    Call UnHookMenu
    Call UnHook
    
End Sub


